Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config.c	(working copy)
@@ -34,6 +34,9 @@
 char default_parallel[PATH_MAX];
 char default_serial[PATH_MAX];
 
+int FastWrite = -1;    /* option -f w<+|-> - perfom a write only nonempty pages of Flash or EEPROM if was errased before*/
+int FastVerify = -1;   /* option -f v<+|-> - perfom a verify only nonempty pages of Flash*/
+
 char string_buf[MAX_STR_CONST];
 char *string_buf_ptr;
 
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config.h
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config.h	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config.h	(working copy)
@@ -55,6 +55,8 @@
 extern char         default_parallel[];
 extern char         default_serial[];
 
+extern int			FastWrite;
+extern int			FastVerify;
 
 
 #if !defined(HAS_YYSTYPE)
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c	(working copy)
@@ -1,103 +1,261 @@
+/* A Bison parser, made by GNU Bison 2.1.  */
 
-/*  A Bison parser, made from ../config_gram.y
-    by GNU Bison version 1.28  */
+/* Skeleton parser for Yacc-like parsing with Bison,
+   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
 
-#define YYBISON 1  /* Identify Bison output.  */
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
 
-#define	K_READ	257
-#define	K_WRITE	258
-#define	K_READ_LO	259
-#define	K_READ_HI	260
-#define	K_WRITE_LO	261
-#define	K_WRITE_HI	262
-#define	K_LOADPAGE_LO	263
-#define	K_LOADPAGE_HI	264
-#define	K_WRITEPAGE	265
-#define	K_CHIP_ERASE	266
-#define	K_PGM_ENABLE	267
-#define	K_MEMORY	268
-#define	K_PAGE_SIZE	269
-#define	K_PAGED	270
-#define	K_BAUDRATE	271
-#define	K_BS2	272
-#define	K_BUFF	273
-#define	K_CHIP_ERASE_DELAY	274
-#define	K_DEDICATED	275
-#define	K_DEFAULT_PARALLEL	276
-#define	K_DEFAULT_PROGRAMMER	277
-#define	K_DEFAULT_SERIAL	278
-#define	K_DESC	279
-#define	K_DEVICECODE	280
-#define	K_STK500_DEVCODE	281
-#define	K_AVR910_DEVCODE	282
-#define	K_EEPROM	283
-#define	K_ERRLED	284
-#define	K_FLASH	285
-#define	K_ID	286
-#define	K_IO	287
-#define	K_JTAG_MKII	288
-#define	K_LOADPAGE	289
-#define	K_MAX_WRITE_DELAY	290
-#define	K_MIN_WRITE_DELAY	291
-#define	K_MISO	292
-#define	K_MOSI	293
-#define	K_NUM_PAGES	294
-#define	K_PAGEL	295
-#define	K_PAR	296
-#define	K_PARALLEL	297
-#define	K_PART	298
-#define	K_PGMLED	299
-#define	K_PROGRAMMER	300
-#define	K_PSEUDO	301
-#define	K_PWROFF_AFTER_WRITE	302
-#define	K_RDYLED	303
-#define	K_READBACK_P1	304
-#define	K_READBACK_P2	305
-#define	K_READMEM	306
-#define	K_RESET	307
-#define	K_RETRY_PULSE	308
-#define	K_SERBB	309
-#define	K_SERIAL	310
-#define	K_SCK	311
-#define	K_SIZE	312
-#define	K_STK500	313
-#define	K_STK500V2	314
-#define	K_AVR910	315
-#define	K_BUTTERFLY	316
-#define	K_TYPE	317
-#define	K_VCC	318
-#define	K_VFYLED	319
-#define	K_NO	320
-#define	K_YES	321
-#define	K_TIMEOUT	322
-#define	K_STABDELAY	323
-#define	K_CMDEXEDELAY	324
-#define	K_SYNCHLOOPS	325
-#define	K_BYTEDELAY	326
-#define	K_POLLVALUE	327
-#define	K_POLLINDEX	328
-#define	K_PREDELAY	329
-#define	K_POSTDELAY	330
-#define	K_POLLMETHOD	331
-#define	K_MODE	332
-#define	K_DELAY	333
-#define	K_BLOCKSIZE	334
-#define	K_READSIZE	335
-#define	K_ALLOWFULLPAGEBITSTREAM	336
-#define	K_ENABLEPAGEPROGRAMMING	337
-#define	K_HAS_JTAG	338
-#define	K_IDR	339
-#define	K_RAMPZ	340
-#define	K_SPMCR	341
-#define	K_EECR	342
-#define	TKN_COMMA	343
-#define	TKN_EQUAL	344
-#define	TKN_SEMI	345
-#define	TKN_TILDE	346
-#define	TKN_NUMBER	347
-#define	TKN_STRING	348
-#define	TKN_ID	349
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
 
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301, USA.  */
+
+/* As a special exception, when this file is copied by Bison into a
+   Bison output file, you may use that output file without restriction.
+   This special exception was added by the Free Software Foundation
+   in version 1.24 of Bison.  */
+
+/* Written by Richard Stallman by simplifying the original so called
+   ``semantic'' parser.  */
+
+/* All symbols defined below should begin with yy or YY, to avoid
+   infringing on user name space.  This should be done even for local
+   variables, as they might otherwise be expanded by user macros.
+   There are some unavoidable exceptions within include files to
+   define necessary library symbols; they are noted "INFRINGES ON
+   USER NAME SPACE" below.  */
+
+/* Identify Bison output.  */
+#define YYBISON 1
+
+/* Bison version.  */
+#define YYBISON_VERSION "2.1"
+
+/* Skeleton name.  */
+#define YYSKELETON_NAME "yacc.c"
+
+/* Pure parsers.  */
+#define YYPURE 0
+
+/* Using locations.  */
+#define YYLSP_NEEDED 0
+
+
+
+/* Tokens.  */
+#ifndef YYTOKENTYPE
+# define YYTOKENTYPE
+   /* Put the tokens into the symbol table, so that GDB and other debuggers
+      know about them.  */
+   enum yytokentype {
+     K_READ = 258,
+     K_WRITE = 259,
+     K_READ_LO = 260,
+     K_READ_HI = 261,
+     K_WRITE_LO = 262,
+     K_WRITE_HI = 263,
+     K_LOADPAGE_LO = 264,
+     K_LOADPAGE_HI = 265,
+     K_WRITEPAGE = 266,
+     K_CHIP_ERASE = 267,
+     K_PGM_ENABLE = 268,
+     K_MEMORY = 269,
+     K_PAGE_SIZE = 270,
+     K_PAGED = 271,
+     K_BAUDRATE = 272,
+     K_BS2 = 273,
+     K_BUFF = 274,
+     K_CHIP_ERASE_DELAY = 275,
+     K_DEDICATED = 276,
+     K_DEFAULT_PARALLEL = 277,
+     K_DEFAULT_PROGRAMMER = 278,
+     K_DEFAULT_SERIAL = 279,
+     K_DESC = 280,
+     K_DEVICECODE = 281,
+     K_STK500_DEVCODE = 282,
+     K_AVR910_DEVCODE = 283,
+     K_EEPROM = 284,
+     K_ERRLED = 285,
+     K_FLASH = 286,
+     K_ID = 287,
+     K_IO = 288,
+     K_JTAG_MKII = 289,
+     K_LOADPAGE = 290,
+     K_MAX_WRITE_DELAY = 291,
+     K_MIN_WRITE_DELAY = 292,
+     K_MISO = 293,
+     K_MOSI = 294,
+     K_NUM_PAGES = 295,
+     K_PAGEL = 296,
+     K_PAR = 297,
+     K_PARALLEL = 298,
+     K_PART = 299,
+     K_PGMLED = 300,
+     K_PROGRAMMER = 301,
+     K_PSEUDO = 302,
+     K_PWROFF_AFTER_WRITE = 303,
+     K_RDYLED = 304,
+     K_READBACK_P1 = 305,
+     K_READBACK_P2 = 306,
+     K_READMEM = 307,
+     K_RESET = 308,
+     K_RETRY_PULSE = 309,
+     K_SERBB = 310,
+     K_SERIAL = 311,
+     K_SCK = 312,
+     K_SIZE = 313,
+     K_STK500 = 314,
+     K_STK500V2 = 315,
+     K_AVR910 = 316,
+     K_BUTTERFLY = 317,
+     K_TYPE = 318,
+     K_VCC = 319,
+     K_VFYLED = 320,
+     K_NO = 321,
+     K_YES = 322,
+     K_TIMEOUT = 323,
+     K_STABDELAY = 324,
+     K_CMDEXEDELAY = 325,
+     K_SYNCHLOOPS = 326,
+     K_BYTEDELAY = 327,
+     K_POLLVALUE = 328,
+     K_POLLINDEX = 329,
+     K_PREDELAY = 330,
+     K_POSTDELAY = 331,
+     K_POLLMETHOD = 332,
+     K_MODE = 333,
+     K_DELAY = 334,
+     K_BLOCKSIZE = 335,
+     K_READSIZE = 336,
+     K_ALLOWFULLPAGEBITSTREAM = 337,
+     K_ENABLEPAGEPROGRAMMING = 338,
+     K_HAS_JTAG = 339,
+     K_IDR = 340,
+     K_RAMPZ = 341,
+     K_SPMCR = 342,
+     K_EECR = 343,
+     TKN_COMMA = 344,
+     TKN_EQUAL = 345,
+     TKN_SEMI = 346,
+     TKN_TILDE = 347,
+     TKN_NUMBER = 348,
+     TKN_STRING = 349,
+     TKN_ID = 350,
+     K_WORD_SIZE = 351,
+     K_DEFAULT_FASTWRITE = 352,
+     K_DEFAULT_FASTVERIFY = 353
+   };
+#endif
+/* Tokens.  */
+#define K_READ 258
+#define K_WRITE 259
+#define K_READ_LO 260
+#define K_READ_HI 261
+#define K_WRITE_LO 262
+#define K_WRITE_HI 263
+#define K_LOADPAGE_LO 264
+#define K_LOADPAGE_HI 265
+#define K_WRITEPAGE 266
+#define K_CHIP_ERASE 267
+#define K_PGM_ENABLE 268
+#define K_MEMORY 269
+#define K_PAGE_SIZE 270
+#define K_PAGED 271
+#define K_BAUDRATE 272
+#define K_BS2 273
+#define K_BUFF 274
+#define K_CHIP_ERASE_DELAY 275
+#define K_DEDICATED 276
+#define K_DEFAULT_PARALLEL 277
+#define K_DEFAULT_PROGRAMMER 278
+#define K_DEFAULT_SERIAL 279
+#define K_DESC 280
+#define K_DEVICECODE 281
+#define K_STK500_DEVCODE 282
+#define K_AVR910_DEVCODE 283
+#define K_EEPROM 284
+#define K_ERRLED 285
+#define K_FLASH 286
+#define K_ID 287
+#define K_IO 288
+#define K_JTAG_MKII 289
+#define K_LOADPAGE 290
+#define K_MAX_WRITE_DELAY 291
+#define K_MIN_WRITE_DELAY 292
+#define K_MISO 293
+#define K_MOSI 294
+#define K_NUM_PAGES 295
+#define K_PAGEL 296
+#define K_PAR 297
+#define K_PARALLEL 298
+#define K_PART 299
+#define K_PGMLED 300
+#define K_PROGRAMMER 301
+#define K_PSEUDO 302
+#define K_PWROFF_AFTER_WRITE 303
+#define K_RDYLED 304
+#define K_READBACK_P1 305
+#define K_READBACK_P2 306
+#define K_READMEM 307
+#define K_RESET 308
+#define K_RETRY_PULSE 309
+#define K_SERBB 310
+#define K_SERIAL 311
+#define K_SCK 312
+#define K_SIZE 313
+#define K_STK500 314
+#define K_STK500V2 315
+#define K_AVR910 316
+#define K_BUTTERFLY 317
+#define K_TYPE 318
+#define K_VCC 319
+#define K_VFYLED 320
+#define K_NO 321
+#define K_YES 322
+#define K_TIMEOUT 323
+#define K_STABDELAY 324
+#define K_CMDEXEDELAY 325
+#define K_SYNCHLOOPS 326
+#define K_BYTEDELAY 327
+#define K_POLLVALUE 328
+#define K_POLLINDEX 329
+#define K_PREDELAY 330
+#define K_POSTDELAY 331
+#define K_POLLMETHOD 332
+#define K_MODE 333
+#define K_DELAY 334
+#define K_BLOCKSIZE 335
+#define K_READSIZE 336
+#define K_ALLOWFULLPAGEBITSTREAM 337
+#define K_ENABLEPAGEPROGRAMMING 338
+#define K_HAS_JTAG 339
+#define K_IDR 340
+#define K_RAMPZ 341
+#define K_SPMCR 342
+#define K_EECR 343
+#define TKN_COMMA 344
+#define TKN_EQUAL 345
+#define TKN_SEMI 346
+#define TKN_TILDE 347
+#define TKN_NUMBER 348
+#define TKN_STRING 349
+#define TKN_ID 350
+#define K_WORD_SIZE 351
+#define K_DEFAULT_FASTWRITE 352
+#define K_DEFAULT_FASTVERIFY 353
+
+
+
+
+/* Copy the first part of user declarations.  */
 #line 21 "../config_gram.y"
 
 
